<?php
/*
Plugin Name: Responsive File Manager for GetSimple
Description: Responsive File Manager plugin Integrated for Getsimple
Version: 2.2
Author: Andrejus Semionovas
Author URI: http://pigios-svetaines.eu/
*/

/* 
 This version uses a slightly modified Layer Slider core to function correctly in GetSimple.
*/

# get correct id for plugin
$thisfile=basename(__FILE__, ".php");

# language support
i18n_merge($thisfile, substr($LANG,0,2)) || i18n_merge($thisfile, $LANG) || i18n_merge($thisfile, 'en') || i18n_merge($thisfile, 'en_US');


$data_path = GSDATAPATH."responsivefilemanager/";
$plugin_path = GSPLUGINPATH."responsivefilemanager/";

# register plugin
register_plugin(
	$thisfile, 										# ID of plugin, should be filename minus php
	'Responsive File Manager', 						# Title of plugin
	'2.2', 											# Version of plugin
	'Andrejus Semionovas',							# Author of plugin
	'http://pigios-svetaines.eu/', 					# Author URL
	i18n_r($thisfile.'/FM_PLUGIN_DESC'), 	    	# Plugin Description
	'files', 										# Page type of plugin
	'responsivefilemanager_get'  					# Function that displays content
);

# activate hooks
add_action('files-sidebar','createSideMenu',array($thisfile,'Responsive File Manager')); 	// Add the sidebar 
add_action('edit-extras', 'editorChangeParams', array());
add_action('theme-footer','rfm_scriptstoFooter');
if($_GET['id'] == "responsivefilemanager") {
	register_style('settings', $SITEURL.'plugins/responsivefilemanager/css/settings.css', '2.2', 'screen');
	queue_style('settings', GSBACK);
}

function responsivefilemanager_get() {
	global $thisfile;
	global $plugin_info;
	global $plugins;
	global $LANG;
	global $data_path;
	global $plugin_path;
	global $SITEURL;
	
$filename = GSPLUGINPATH.'responsivefilemanager/config/config.php';
$file = fopen($filename, "r")  or die("Couldn't open $filename");
$thumb_true = false;
while(!feof($file)){
    $line = fgets($file);
	$pos = strpos($line, 'upload_dir');
	if ($pos !== false) {
		$rfm_upload = substr($line, strpos($line, '/'), (rtrim(strpos($line, ','))-strpos($line, '/'))-1);
	}
	elseif (strpos($line, "fixed_image_creation'")!==false) {
		$rfm_true = trim(str_replace(array("'fixed_image_creation'", "=", ">", ","), "", $line));
		if(strtolower($rfm_true) == 'false') {
			break;
		} else $thumb_true = true;
	}
	elseif (strpos($line, "fixed_image_creation_name_to_prepend")!==false) {
		$th_prep =trim(str_replace(array("'fixed_image_creation_name_to_prepend'", "=", ">", "array(", "),", ") ,"), "", $line));
	}
	elseif (strpos($line, "fixed_image_creation_to_append")!==false) {
		$th_appe =trim(str_replace(array("'fixed_image_creation_to_append'", "=", ">", "array(", "),", ") ,"), "", $line));
	}
	elseif (strpos($line, "fixed_image_creation_width")!==false) {
		$th_width =trim(str_replace(array("'fixed_image_creation_width'", "=", ">", "array(", "),", ") ,"), "", $line));
	}
	elseif (strpos($line, "fixed_image_creation_height")!==false) {
		$th_height = trim(str_replace(array("'fixed_image_creation_height'", "=", ">", "array(", "),", ") ,"), "", $line));
	}
	elseif (strpos($line, "fixed_image_creation_option")!==false) {
		$th_option = trim(str_replace(array("'fixed_image_creation_option'", "=", ">", "array(", "),", ") ,"), "", $line));
		break;
	}
}
fclose($file);

$urls = parse_url($SITEURL, PHP_URL_PATH);
if($urls == "/") $upload_d = "/data/uploads/";
else  $upload_d = $urls."data/uploads/";
if ($rfm_upload != $upload_d) {
	$file_temp = GSPLUGINPATH.'responsivefilemanager/config/config.tmp';
	$file = fopen($filename, "r")  or die("Couldn't open $filename");
	$file_new = fopen($file_temp, "w")  or die("Couldn't open $file_temp");
	while(!feof($file)){
    $line = fgets($file);
	$pos = strpos($line, 'upload_dir');
	if ($pos !== false) {
		fwrite($file_new, "\t'upload_dir' => '".$upload_d."',\n");
	}
	else {
		fwrite($file_new, $line);
	}
	}
	fclose($file);
	fclose($file_new);
	unlink($filename);
	rename($file_temp, $filename);
?> <div class="fancy-message info"><p><?php i18n('responsivefilemanager/FILE_UPLOAD'); echo $upload_d; ?></p></div> <?php
}
	
	if(file_exists($plugin_path."lang/".$LANG.".php")) $lang_curr = $LANG;
	else $lang_curr = substr($LANG,0,2);
	if(isset($_POST['rfm_replace']) && $_POST['rfm_replace']) {
			if (check_plugin()) {
				$rfm_xml = getXML(GSDATAOTHERPATH . 'rfm_config.xml');
				$rfm_xml->replace = 1;
				XMLsave($rfm_xml, GSDATAOTHERPATH.'rfm_config.xml');
				?> <div class="fancy-message seccess"><p><?php i18n('responsivefilemanager/FM_INTEGR_SECC'); ?></p></div> <?php
				if(!file_exists(GSADMINPATH.'template/js/ckeditor/plugins/thumb/plugin.js') || !file_exists(GSADMINPATH.'template/js/ckeditor/plugins/thumb/dialogs/thumb.js')) {
					?> <div class="fancy-message error"><p><?php i18n('responsivefilemanager/FM_THUMB_FAIL'); ?></p></div> <?php
				}
			}
			else {
				?> <div class="fancy-message error"><p><?php i18n('responsivefilemanager/FM_THUMB_ERR'); ?></p></div> <?php
			}
	}

	if(isset($_POST['rfm_dereplace']) && $_POST['rfm_dereplace']) {
		if(file_exists(GSADMINPATH.'template/js/ckeditor/plugins/thumb')) {
			recursiveRemoveDirectory(GSADMINPATH.'template/js/ckeditor/plugins/thumb');
		}
		$rfm_xml = getXML(GSDATAOTHERPATH . 'rfm_config.xml');
		$rfm_xml->replace = '';
		XMLsave($rfm_xml, GSDATAOTHERPATH.'rfm_config.xml');
		?> <div class="fancy-message seccess"><p><?php i18n('responsivefilemanager/FM_INTEGR_CANC'); ?></p></div> <?php
				
	}
	if(isset($_POST['rfm_save']) && $_POST['rfm_save']) {
		$rfm_xml = getXML(GSDATAOTHERPATH . 'rfm_config.xml');
		$rfm_xml->w_width = str_replace(array("px"," "), "", $_POST['rfm_w_width']);
		$rfm_xml->w_height = str_replace(array("px"," "), "", $_POST['rfm_w_height']);
		if(isset($_POST['rfm_toolbar']) && !empty($_POST['rfm_toolbar'])) {
			$rfm_xml->toolbar = $_POST['rfm_toolbar']; }
		else { $rfm_xml->toolbar = 0; }
		if(isset($_POST['rfm_jquery']) && !empty($_POST['rfm_jquery'])) {
			$rfm_xml->jquery = $_POST['rfm_jquery']; }
		else { $rfm_xml->jquery = 0; }
		XMLsave($rfm_xml, GSDATAOTHERPATH.'rfm_config.xml');
		?> <div class="fancy-message seccess"><p><?php i18n('responsivefilemanager/FM_LANG_PARAM'); ?></p></div> <?php
	}
	if(isset($_POST['thumbs_save']) && $_POST['thumbs_save']) {
		if(isset($_POST['thumbs_defa']) && !empty($_POST['thumbs_defa'])) {
			$file_temp = GSPLUGINPATH.'responsivefilemanager/config/config.tmp';
			$file = fopen($filename, "r")  or die("Couldn't open $filename");
			$file_new = fopen($file_temp, "w")  or die("Couldn't open $file_temp");
			while(!feof($file)){
				$line = fgets($file);
				if(strpos($line, "fixed_image_creation'")!==false) {
					fwrite($file_new, "\t'fixed_image_creation' => false,\n");
				}
				else {
					fwrite($file_new, $line);
				}
			}
			fclose($file);
			fclose($file_new);
			unlink($filename);
			rename($file_temp, $filename);
			?> <div class="fancy-message seccess"><p><?php i18n('responsivefilemanager/FM_LANG_PARAM'); ?></p></div> <?php
		}
		if(isset($_POST['thumb_prefix']) && !empty($_POST['thumb_prefix']) && isset($_POST['thumb_suffix']) && !empty($_POST['thumb_suffix']) && isset($_POST['thumb_width']) && !empty($_POST['thumb_width']) && isset($_POST['thumb_height']) && !empty($_POST['thumb_height']) && isset($_POST['thumb_opt']) && !empty($_POST['thumb_opt'])) {
			$file_temp = GSPLUGINPATH.'responsivefilemanager/config/config.tmp';
			$file = fopen($filename, "r")  or die("Couldn't open $filename");
			$file_new = fopen($file_temp, "w")  or die("Couldn't open $file_temp");
			$count = count(explode(",", $_POST['thumb_width']));
			while(!feof($file)){
				$line = fgets($file);
				switch (true){
					case (strpos($line, "fixed_image_creation'")!==false):
						fwrite($file_new, "\t'fixed_image_creation' => true,\n");
						break;
					case (strpos($line, 'fixed_path_from_filemanager')!==false):
						fwrite($file_new, "\t'fixed_path_from_filemanager' => array( ");
						for( $i= 0 ; $i < $count ; $i++ ) {
							if($count == ($i+1)) fwrite($file_new, "'../../data/thumbs/'");
							else  fwrite($file_new, "'../../data/thumbs/', ");
						}
						fwrite($file_new, " ),\n");
						break;
					case (strpos($line, 'fixed_image_creation_name_to_prepend')!==false):
						fwrite($file_new, "\t'fixed_image_creation_name_to_prepend' => array( ".$_POST['thumb_prefix']." ),\n");
						break;
					case (strpos($line,'fixed_image_creation_to_append')!==false):
						fwrite($file_new, "\t'fixed_image_creation_to_append' => array( ".$_POST['thumb_suffix']." ),\n");
						break;
					case (strpos($line,'fixed_image_creation_width')!==false):
						fwrite($file_new, "\t'fixed_image_creation_width' => array( ".$_POST['thumb_width']." ),\n");
						break;
					case (strpos($line,'fixed_image_creation_height')!==false):
						fwrite($file_new, "\t'fixed_image_creation_height' => array( ".$_POST['thumb_height']." ),\n");
						break;
					case (strpos($line,'fixed_image_creation_option')!==false):
						fwrite($file_new, "\t'fixed_image_creation_option' => array( ".$_POST['thumb_opt']." ),\n");
						break;
					default:
						fwrite($file_new, $line);
						break;
				}
			}
			fclose($file);
			fclose($file_new);
			unlink($filename);
			rename($file_temp, $filename);
			?> <div class="fancy-message seccess"><p><?php i18n('responsivefilemanager/FM_LANG_PARAM'); ?></p></div> <?php
		}
		else {
			if(!isset($_POST['thumbs_defa']) && empty($_POST['thumbs_defa'])) {
		?> <div class="fancy-message error"><p><?php i18n('responsivefilemanager/FM_THUMB_SET_ERR'); ?></p></div> <?php
			}
		}
	}
	if (!file_exists(GSDATAOTHERPATH.'rfm_config.xml')) {
		$rfm_xml = @new SimpleXMLExtended('<?xml version="1.0" encoding="UTF-8"?><rfm_config></rfm_config>');
		$rfm_xml->addChild('replace', false);
		$rfm_xml->addChild('toolbar', false);
		$rfm_xml->addChild('jquery', false);
		$rfm_xml->addChild('w_width', "75%");
		$rfm_xml->addChild('w_height', "60%");
		XMLsave($rfm_xml, GSDATAOTHERPATH.'rfm_config.xml');
	}
	else {
		$rfm_xml = getXML(GSDATAOTHERPATH . 'rfm_config.xml');
		$rfm_replace = $rfm_xml->replace;
		$win_width = $rfm_xml->w_width;
		$win_height = $rfm_xml->w_height;
		$rfm_toolbar = $rfm_xml->toolbar;
		$rfm_jquery = $rfm_xml->jquery;
		$thumb_pref = $rfm_xml->thumb_pref;
		$thumb_suff = $rfm_xml->thumb_suff;
	}
?>
	<h3 class="floated" style="float:left">Responsive FileManager</h3>
	<div class="edit-nav">
        <p>
		 <a href="../plugins/responsivefilemanager/dialog.php?type=0&lang=<?php echo $lang_curr; ?>" class="btn iframe-btn" type="button"><?php i18n('responsivefilemanager/OPEN_FM'); ?></a>
        </p>
        <div class="clear"></div>
    </div>
	
	<div id="respfm"> 
		<div id="respbrowser">
			<iframe name="respfm" id="respframe" frameborder="0" width="100%" height="550px" src="../plugins/responsivefilemanager/dialog.php?type=0&lang=<?php echo $lang_curr; ?>">
			</iframe>
		</div>
	</div>
	<form action="<?php echo $_SERVER['REQUEST_URI'] ?>" method="post" class="rfm-postform">
		<fieldset class="container-collapsed" id="container-0">
		<legend class="collapsedlegend"><?php i18n('responsivefilemanager/FM_SET_EXPAND'); ?></legend>
		<h3 style="margin:20px 10px"><?php i18n('responsivefilemanager/FM_SET_INTEGR'); ?></h3>
		<div class="edit-settings">
		<?php if (isset($rfm_replace) && $rfm_replace == 1) : ?>
			<div class="inner-divs"><span class="rfm-activate"><?php i18n('responsivefilemanager/FM_SET_INTEGR_SECC'); ?></span>
			<input type="submit" name="rfm_dereplace" class="iframe-buttn" value="<?php i18n('responsivefilemanager/FM_BTN_RESTORE'); ?>"/></div>
			<div class="inner-divs"><span class="rfm-activate"><?php i18n('responsivefilemanager/FM_SET_WIDTH'); ?></span>
			<input type="text" name="rfm_w_width" class="rfm_input" value="<?php echo (isset($win_width) && strpos($win_width,'%')) === false ? $win_width.'px' : $win_width; ?>"/></div>
			<div class="inner-divs"><span class="rfm-activate"><?php i18n('responsivefilemanager/FM_SET_HEIGHT'); ?></span>
			<input type="text" name="rfm_w_height" class="rfm_input" value="<?php echo (isset($win_height) && strpos($win_height,'%')) === false ? $win_height.'px' : $win_height; ?>"/></div>
			<div class="inner-divs"><span class="rfm-activate"><?php i18n('responsivefilemanager/FM_SET_TOOLBAR'); ?></span>
			<input type="checkbox" name="rfm_toolbar" class="rfm_input" value=1 <?php echo $rfm_toolbar==1?"checked":"" ?>/></div>
			<div class="inner-divs"><span class="rfm-activate"><?php i18n('responsivefilemanager/FM_SET_JQUERY'); ?></span>
			<input type="checkbox" name="rfm_jquery" class="rfm_input" value=1 <?php echo $rfm_jquery==1?"checked":"" ?>/></div>
			<div class="inner-divs"><input type="submit" name="rfm_save" class="iframe-buttn" value="<?php i18n('responsivefilemanager/FM_BTN_SAVE'); ?>" style="float:left; margin-bottom:20px;"/></div>
		<?php else: ?>
			<div class="inner-divs"><span class="rfm-activate"><?php i18n('responsivefilemanager/FM_SET_NOINTEGR'); ?></span>
			<input type="submit" name="rfm_replace" class="iframe-buttn" value="<?php i18n('responsivefilemanager/FM_BTN_INTEGR'); ?>"/></div>
		<?php endif; ?>
		</div>
		</fieldset>
	</form>
	<form action="<?php echo $_SERVER['REQUEST_URI'] ?>" method="post" class="rfm-postform">
		<fieldset class="container-collapsed" id="container-1">
			<legend class="collapsedlegend"><?php i18n('responsivefilemanager/FM_SET_EXPAND'); ?></legend>
			<h3 style="margin:20px 10px"><?php i18n('responsivefilemanager/FM_SET_THUMB'); ?></h3>
			<div class="edit-settings"> <?php
			if(!$thumb_true) { ?>
				<div class="inner-divs" style="color: blue; font-style: italic; padding-bottom: 6px;">
					<?php i18n('responsivefilemanager/FM_THUMB_DEFA_DESC'); ?>
				</div>
	<?php	} ?>
				<div class="inner-divs"><span class="rfm-activate"><?php i18n('responsivefilemanager/FM_THUMB_PREFIX'); ?></span><span class="required">*</span>
					<input type="text" name="thumb_prefix" class="text" value="<?php echo (isset($th_prep) && !empty($th_prep))?$th_prep:'' ?>"/>
				</div>
				<div class="inner-divs"><span class="rfm-activate"><?php i18n('responsivefilemanager/FM_THUMB_SUFFIX'); ?></span><span class="required">*</span>
					<input type="text" name="thumb_suffix" class="text" value="<?php echo (isset($th_appe) && !empty($th_appe))?$th_appe:'' ?>"/>
				</div>
				<div class="inner-divs" style="white-space: normal; font-weight: 400; font-size: 13px; font-style: italic;"><?php i18n('responsivefilemanager/FM_THUMB_SUFFIX_DESC'); ?></div>
				<hr style="color: #f6f6f6; margin-bottom: 20px;">
				<div class="inner-divs"><span class="rfm-activate"><?php i18n('responsivefilemanager/FM_THUMB_WIDTH'); ?></span><span class="required">*</span>
					<input type="text" name="thumb_width" class="text" value="<?php echo (isset($th_width) && !empty($th_width))?$th_width:'' ?>"/>
				</div>
				<div class="inner-divs"><span class="rfm-activate"><?php i18n('responsivefilemanager/FM_THUMB_HEIGHT'); ?></span><span class="required">*</span>
					<input type="text" name="thumb_height" class="text" value="<?php echo (isset($th_height) && !empty($th_height))?$th_height:'' ?>"/>
				</div>
				<div class="inner-divs" style="white-space: normal; font-weight: 400; font-size: 13px; font-style: italic;"><?php i18n('responsivefilemanager/FM_THUMB_WIDTH_DESC'); ?></div>
				<hr style="color: #f6f6f6; margin-bottom: 20px;">
				<div class="inner-divs"><span class="rfm-activate"><?php i18n('responsivefilemanager/FM_THUMB_OPTION'); ?></span><span class="required">*</span>
					<input type="text" name="thumb_opt" id="thumb_options" class="text" value="<?php echo (isset($th_option) && !empty($th_option))?$th_option:'' ?>"/>
				</div>
				<div class="inner-divs">
					<div class="leftsec">
						<select name="opt_values" id="option_values" class="text" style="width: auto; margin-top: 10px;">
							<option value="exact">Exact (defined size)</option>
							<option value="portrait">Portrait (keep aspect by height)</option>
							<option value="landscape">Landscape (keep aspect by width)</option>
							<option value="auto">Auto (automatic resize)</option>
							<option value="crop">Crop (resize and crop)</option>
						</select>
						<button type='button' id="add_option" style="height: 28px;">Add</button>
					</div>
					<div class="rightsec">
						<label for="thumbs_defa" style="float: right; padding-right: 20px;"><?php i18n('responsivefilemanager/FM_THUMB_DEFAULT'); ?></label>
						<input type="checkbox" id="thumbs_defa" name="thumbs_defa" class="rfm_input" value=1 />
					</div>
				</div>
				<div class="inner-divs"><input type="submit" name="thumbs_save" class="iframe-buttn" value="<?php i18n('responsivefilemanager/FM_BTN_SAVE'); ?>" style="float:left; margin-bottom:20px;"/></div>
				<div class="inner-divs"><span style="position: relative;left: 480px;top: -28px;"><a id="exmpl1" href="#"><?php i18n('responsivefilemanager/FM_EXAMPLE'); ?> 1</a></span><span style="position: relative;left: 506px;top: -28px;"><a id="exmpl2" href="#"><?php i18n('responsivefilemanager/FM_EXAMPLE'); ?> 2</a></span></div>
				<div id="example1" class="inner-divs" style="display:none">
					<code style="color: green;">'name to prepend' => 'thumb.'<br>'thumbnail width' => 250<br>'thumbnail height' => ''<br>'creation options' => 'landscape'</code>
					<p style="padding-top: 10px;"><?php i18n('responsivefilemanager/FM_EXMPL1'); ?></p>
				</div>
				<div id="example2" class="inner-divs" style="display:none">
					<code style="color: green;">'name to append' => '_thumb', '.thumbnail'<br>'thumbnail width' => 250, ''<br>'thumbnail height' => 200, 300<br>'creation options' => 'crop', 'auto'</code>
					<p style="padding-top: 10px;"><?php i18n('responsivefilemanager/FM_EXMPL2'); ?></p>
				</div>
			</div>
		</fieldset>
	</form>
<script type="text/javascript">
$('#exmpl1').click( function(e) {
    e.preventDefault();
    $( "#example1" ).toggle();
});
$('#exmpl2').click( function(e) {
    e.preventDefault();
    $( "#example2" ).toggle();
});
jQuery('#add_option').click(function(){
	var selected = $("#option_values").val();
	var input = $( "#thumb_options" );
	if($.trim(input.val()).length == 0) {
		input.val( input.val() + "'" + selected + "'" );
	}
	else {
		input.val( input.val() + ",'" + selected + "'" );
	}
});
jQuery('.collapsedlegend').click(function(){
	 var path = '<?php echo $SITEURL; ?>';
	 var expand = '<?php i18n('responsivefilemanager/FM_SET_EXPAND'); ?>';
	 var colapse = '<?php i18n('responsivefilemanager/FM_SET_COLAPS'); ?>';
	if($(this).text()==expand){
		jQuery(this).parent('fieldset').find('div:first').show(500);
		jQuery(this).text(colapse);
		jQuery(this).css('background-image', 'url('+path+'admin/template/images/tick.png)');
	}else{
		jQuery(this).parent('fieldset').find('div:first').hide(500);
		jQuery(this).text(expand);
		jQuery(this).css('background-image', 'url('+path+'admin/template/images/utick.png)');
	}
});
jQuery(function(){
   setTimeout(function() {
       jQuery(".fancy-message.seccess").hide('slow');
   }, 10000);
});
jQuery('.iframe-btn').fancybox({	
	'width'		: 900,
	'height'	: 600,
	'type'		: 'iframe',
	'autoScale'    	: false
});
jQuery('.groups').on('change', function() {
   jQuery('.groups').not(this).prop('checked', false);
});
</script>
<?php
}
function editorChangeParams() {
	global $GSEDITORBROWSER;
	global $LANG;
	global $plugin_path;
	global $filebrowserBrowseUrl;
	global $filebrowserUploadUrl;
	global $filebrowserImageBrowseUrl;
	global $filebrowserWidth;
	global $filebrowserHeight;
	global $toolbar_ins;
	
	if(file_exists($plugin_path."lang/".$LANG.".php")) $lang_curr = $LANG;
	else $lang_curr = substr($LANG,0,2);
	
	if (file_exists(GSDATAOTHERPATH.'rfm_config.xml')) {
		$rfm_xml = getXML(GSDATAOTHERPATH . 'rfm_config.xml');
	}
	if(empty($rfm_xml->replace)) $GSEDITORBROWSER = FALSE;
	else $GSEDITORBROWSER = $rfm_xml->replace;
	if(empty($rfm_xml->toolbar)) $toolbar_ins = FALSE;
	else $toolbar_ins = $rfm_xml->toolbar;
	if($GSEDITORBROWSER) {
        $filebrowserBrowseUrl = "../plugins/responsivefilemanager/dialog.php?type=2&lang=".$lang_curr."&editor=ckeditor&fldr=";
        $filebrowserUploadUrl = "../plugins/responsivefilemanager/dialog.php?type=2&lang=".$lang_curr."&editor=ckeditor&fldr=";
        $filebrowserImageBrowseUrl = "../plugins/responsivefilemanager/dialog.php?type=1&lang=".$lang_curr."&editor=ckeditor&fldr=";
        $filebrowserWidth = $rfm_xml->w_width;
        $filebrowserHeight = $rfm_xml->w_height;

// gsconfig GSEDITOROPTIONS is stored in global $EDOPTIONS, you can append whatever you want
        GLOBAL $EDOPTIONS;
		GLOBAL $EDTOOL;
		$EDOPTIONS .= ',
		filebrowserBrowseUrl:"'.$filebrowserBrowseUrl.'"';
		$EDOPTIONS .= ',
		filebrowserImageBrowseUrl:"'.$filebrowserImageBrowseUrl.'"';
		$EDOPTIONS .= ',
		filebrowserWindowWidth:"'.$filebrowserWidth.'"';
		$EDOPTIONS .= ',
		filebrowserWindowHeight:"'.$filebrowserHeight.'"';
		$EDOPTIONS .= ',
		extraPlugins:"thumb"';
		if($toolbar_ins) {
			$EDTOOL='[["Bold", "Italic", "Underline", "Strike", "Subscript", "Superscript", "NumberedList", "BulletedList", "JustifyLeft", "JustifyCenter", "JustifyRight", "JustifyBlock", "HorizontalRule", "Table", "TextColor", "BGColor", "Link", "Unlink", "Anchor", "Image", "Thumb", "Youtube"], "/", ["Styles", "Format", "FontSize", "Video", "Flash", "CreateDiv", "Iframe", "SpecialChar", "RemoveFormat", "Undo", "Redo", "Source"]]';
		}
		else {
			if(strpos($EDTOOL,'advanced') !== false) {
				$EDTOOL='[["Bold", "Italic", "Underline", "NumberedList", "BulletedList", "JustifyLeft","JustifyCenter","JustifyRight","JustifyBlock", "Table", "TextColor", "BGColor", "Link", "Unlink", "Image", "RemoveFormat", "Source"],"/",["Styles","Format","Font","FontSize"]]';
			}
			if(strpos($EDTOOL,'basic') !== false) {
				$EDTOOL='[["Bold", "Italic", "Underline", "NumberedList", "BulletedList", "JustifyLeft","JustifyCenter","JustifyRight","JustifyBlock", "Link", "Unlink", "Image", "RemoveFormat", "Source"]]';
			}
			$EDTOOL=str_replace(']]', ',"Thumb"]]', $EDTOOL);
			
		}
	}
}

function check_plugin() {
	if(!file_exists(GSADMINPATH.'template/js/ckeditor/plugins/thumb')) {
		if (!mkdir(GSADMINPATH.'template/js/ckeditor/plugins/thumb', 0777, true)) {
			die('Failed to create folders...');
			return false;
		}
		elseif (!mkdir(GSADMINPATH.'template/js/ckeditor/plugins/thumb/dialogs', 0777, true)) {
			die('Failed to create folders...');
			return false;
			}
				elseif (!mkdir(GSADMINPATH.'template/js/ckeditor/plugins/thumb/icons', 0777, true)) {
					die('Failed to create folders...');
					return false;
				}
		$myplugin = fopen(GSADMINPATH.'template/js/ckeditor/plugins/thumb/plugin.js', "w") or die("Unable to open file!");
		$line = "CKEDITOR.plugins.add( 'thumb', {
    icons: this.path + 'thumb',
    init: function( editor ) {
        editor.addCommand( 'thumbDialog', new CKEDITOR.dialogCommand( 'thumbDialog' ) );
        editor.ui.addButton( 'Thumb', {
            label: 'Insert Thumbnail',
            command: 'thumbDialog',
			icon: this.path + 'icons/thumb.png',
            toolbar: 'insert'
        });

        CKEDITOR.dialog.add( 'thumbDialog', this.path + 'dialogs/thumb.js' );
    }
});";
		fwrite($myplugin, $line);
		fclose($myplugin);
		$myplugin1 = fopen(GSADMINPATH.'template/js/ckeditor/plugins/thumb/dialogs/thumb.js', "w") or die("Unable to open file!");
		$line = "CKEDITOR.dialog.add( 'thumbDialog', function( editor ) {
	return {
		title : editor.lang.image.title,
		minWidth : 400,
		minHeight : 160,
		contents : [
			{
				id : 'general',
				label : 'Settings',
				elements : [
					{
						type : 'text',
						id : 'file_url',
						label : editor.lang.common.url,
						validate : CKEDITOR.dialog.validate.notEmpty( 'The link must have a URL.' ),
						required : true,
						commit : function( data )
							{
								data.file_url = this.getValue();
							}
					},
					{
						id:'img_url',
						type:'text',
						hidden : true,
						label:editor.lang.image.url,accessKey:'A',
						'default':'',
						commit : function( data )
							{
								data.img_url = this.getValue();
							}
					},
					{
						type : 'button',
						hidden : true,
						id : 'browse',
						style : 'display:inline-block;margin-bottom:10px;float: right;',
						align : 'center',
						label : editor.lang.common.browseServer,
						filebrowser : {
							action : 'Browse',
							onSelect : function( fileUrl, data ) {
								var dialog = this.getDialog();
								dialog.getContentElement( 'general', 'file_url' ).setValue( fileUrl.replace(\"uploads\", \"thumbs\") );
								dialog.getContentElement( 'general', 'img_url' ).setValue( fileUrl );
								return false;
							}
						}
					},
					{
						id:'txtAlt',
						type:'text',
						label:editor.lang.image.alt,accessKey:'A',
						'default':'',
						commit : function( data )
							{
								data.txtAlt = this.getValue();
							}
					},
					{
						type:'hbox',
						children:[
							{
								type: 'select',
								id: 'img_Align',
								label: editor.lang.common.align,
								items:[[editor.lang.common.notSet,''], [editor.lang.common.alignLeft,'left'],[editor.lang.common.alignRight,'right']],
								commit : function( data ) {
									data.img_Align = this.getValue();
								}
							},
							{
								type: 'select',
								id: 'img_loader',
								label: editor.lang.common.target,
								items:[[editor.lang.common.targetNew,'_blank'], [editor.lang.common.targetSelf,'_self'], ['prettyPhoto','prettyPhoto'], ['FancyBox','fancybox'], ['BaguetteBox','baguettebox']],
								'default':'prettyPhoto',
								onChange: function( api ) {
									var dialog = CKEDITOR.dialog.getCurrent();
									var element_id = dialog.getContentElement( 'general', 'baguette_settings' );
									if(this.getValue() == 'baguettebox') {
										element_id.getElement().show();
									}
									else {
										element_id.getElement().hide();
									}
								},
								commit : function( data ) {
									data.img_loader = this.getValue();
								}
							},
							{
								id:'img_margins',
								type:'text',
								label:'Margins (px)',
								validate: CKEDITOR.dialog.validate.integer(editor.lang.common.validateNumberFailed),
								'default':'',
								commit : function( data ) {
									data.img_margins = this.getValue();
								}
							},
					]},
					{
						type:'hbox',
						id:'baguette_settings',
						hidden : true,
						children:[
							{
								type: 'checkbox',
								id: 'baguette_first',
								label: 'Start a new gallery',
								title: 'Check if this image is the first in the gallery',
								'default': false,
								commit : function( data ) {
									data.baguette_first = this.getValue();
								}
							},
					]},
				]
			}
		],
		onOk : function() {
			var dialog = this, data = {}, reff = editor.document.createElement( 'a' ); 
			var styles = 'border: 0 none;';
			this.commitContent( data );
			if(data.img_margins) {
				styles = styles + ' margin: '+data.img_margins+'px;';
			}
			reff.setAttribute('href', data.img_url);
			if(data.img_loader == '_blank' || data.img_loader == '_self') {
				reff.setAttribute('target', data.img_loader);
			} else {
				reff.setAttribute('class', data.img_loader+'Box');
				if(data.img_loader != 'baguettebox') {
					reff.setAttribute('rel', data.img_loader+'[myGallery]');
				}
			}
			if(data.img_Align == 'left' || data.img_Align == 'right') {
				styles = styles + ' float: '+data.img_Align+';';
			}
			if(data.baguette_first) {
				divf = editor.document.createElement( 'div' );
				divf.setAttribute('class', 'baguettebox');
				divf.setHtml( '<a href=\"'+data.img_url+'\"><img class=\"'+data.img_loader+'Img\" alt=\"'+data.txtAlt+'\" src=\"'+data.file_url+'\" style=\"'+styles+'\" /></a>' );
				editor.insertElement( divf );
			}
			else {
				reff.setHtml( '<img class=\"'+data.img_loader+'Img\" alt=\"'+data.txtAlt+'\" src=\"'+data.file_url+'\" style=\"'+styles+'\" />' );
			}
			editor.insertElement( reff );
		}
	};
});";
		fwrite($myplugin1, $line);
		fclose($myplugin1);
		$icon_file = GSPLUGINPATH."responsivefilemanager/img/thumb.png";
		if(!file_exists($icon_file)) {
			$icon_file = GSPLUGINPATH."responsivefilemanager/img/thumbnail.png";
		}
		if (!copy($icon_file, GSADMINPATH.'template/js/ckeditor/plugins/thumb/icons/thumb.png')) {
			echo "failed to copy $icon_file...\n";
			return false;
		}
		return true;
	}
	return true;
}

function recursiveRemoveDirectory($directory) {
    foreach(glob("{$directory}/*") as $file) {
        if(is_dir($file)) {
            recursiveRemoveDirectory($file);
        } else {
            unlink($file);
        }
    }
    rmdir($directory);
}

function rfm_scriptstoFooter() {
global $SITEURL;
if (file_exists(GSDATAOTHERPATH.'rfm_config.xml')) {
	$rfm_xml = getXML(GSDATAOTHERPATH . 'rfm_config.xml');
	$rfm_jquery = $rfm_xml->jquery;
}
if (isset($rfm_jquery) && $rfm_jquery == 1) { ?>
<script>
function loadjscssfile(filename, filetype){
    if (filetype=="js"){ //if filename is a external JavaScript file
        var fileref=document.createElement('script');
        fileref.setAttribute("type","text/javascript");
        fileref.setAttribute("src", filename);
		fileref.async = false;
    }
    else if (filetype=="css"){ //if filename is an external CSS file
        var fileref=document.createElement("link");
        fileref.setAttribute("rel", "stylesheet");
        fileref.setAttribute("type", "text/css");
        fileref.setAttribute("href", filename);
    }
    if (typeof fileref!="undefined") {
		document.body.appendChild(fileref);
	}
}
if (window.addEventListener)
	window.addEventListener("load", loadjscssfile, false);
else if (window.attachEvent)
	window.attachEvent("onload", loadjscssfile);
else window.onload = loadjscssfile;

if (document.querySelector('.prettyPhotoBox') !== null || document.querySelector('.fancyboxBox') !== null) {
	loadjscssfile("<?php echo $SITEURL; ?>admin/template/js/jquery.min.js", "js");
}
</script> <?php	
}
?>
<!-- Responsive FileManager Javascripts loading -->
<script>
if (document.querySelector('.prettyPhotoBox') !== null) {
	loadjscssfile("<?php echo $SITEURL; ?>plugins/responsivefilemanager/css/prettyPhoto.css", "css");
	loadjscssfile("<?php echo $SITEURL; ?>plugins/responsivefilemanager/js/prettyPhoto/jquery.prettyPhoto.js", "js");
	loadjscssfile("<?php echo $SITEURL; ?>plugins/responsivefilemanager/js/prettyPhoto/rfm_prettyphoto.js", "js");
}
if (document.querySelector('.fancyboxBox') !== null) {
	loadjscssfile("<?php echo $SITEURL; ?>plugins/responsivefilemanager/js/FancyBox/jquery.fancybox.css", "css");
	loadjscssfile("<?php echo $SITEURL; ?>plugins/responsivefilemanager/js/FancyBox/jquery.fancybox.pack.js", "js");
	loadjscssfile("<?php echo $SITEURL; ?>plugins/responsivefilemanager/js/FancyBox/rfm_fancybox.js", "js");
}
if (document.querySelector('.baguettebox') !== null) {
	loadjscssfile("<?php echo $SITEURL; ?>plugins/responsivefilemanager/js/BaguetteBox/baguetteBox.min.css", "css");
	loadjscssfile("<?php echo $SITEURL; ?>plugins/responsivefilemanager/js/BaguetteBox/baguetteBox.min.js", "js");
	window.onload = function() {
		baguetteBox.run('.baguettebox', {
			// Custom options
			fullScreen: false,
			animation: 'fadeIn',
			buttons: true,
			overlayBackgroundColor: 'rgba (0,0,0,.8)',
			captions: function(element) {
				return element.getElementsByTagName('img')[0].alt;
			}
		});
	};
}
</script>
<?php
}
?>