CKEDITOR.dialog.add( 'thumbDialog', function( editor ) {
	return {
		title : editor.lang.image.title,
		minWidth : 400,
		minHeight : 160,
		contents : [
			{
				id : 'general',
				label : 'Settings',
				elements : [
					{
						type : 'text',
						id : 'file_url',
						label : editor.lang.common.url,
						validate : CKEDITOR.dialog.validate.notEmpty( 'The link must have a URL.' ),
						required : true,
						commit : function( data )
							{
								data.file_url = this.getValue();
							}
					},
					{
						id:'img_url',
						type:'text',
						hidden : true,
						label:editor.lang.image.url,accessKey:'A',
						'default':'',
						commit : function( data )
							{
								data.img_url = this.getValue();
							}
					},
					{
						type : 'button',
						hidden : true,
						id : 'browse',
						style : 'display:inline-block;margin-bottom:10px;float: right;',
						align : 'center',
						label : editor.lang.common.browseServer,
						filebrowser : {
							action : 'Browse',
							onSelect : function( fileUrl, data ) {
								var dialog = this.getDialog();
								dialog.getContentElement( 'general', 'file_url' ).setValue( fileUrl.replace("uploads", "thumbs") );
								dialog.getContentElement( 'general', 'img_url' ).setValue( fileUrl );
								return false;
							}
						}
					},
					{
						id:'txtAlt',
						type:'text',
						label:editor.lang.image.alt,accessKey:'A',
						'default':'',
						commit : function( data )
							{
								data.txtAlt = this.getValue();
							}
					},
					{
						type:'hbox',
						children:[
							{
								type: 'select',
								id: 'img_Align',
								label: editor.lang.common.align,
								items:[[editor.lang.common.notSet,''], [editor.lang.common.alignLeft,'left'],[editor.lang.common.alignRight,'right']],
								commit : function( data ) {
									data.img_Align = this.getValue();
								}
							},
							{
								type: 'select',
								id: 'img_loader',
								label: editor.lang.common.target,
								items:[[editor.lang.common.targetNew,'_blank'], [editor.lang.common.targetSelf,'_self'], ['prettyPhoto','prettyPhoto'], ['FancyBox','fancybox'], ['BaguetteBox','baguettebox']],
								'default':'prettyPhoto',
								onChange: function( api ) {
									var dialog = CKEDITOR.dialog.getCurrent();
									var element_id = dialog.getContentElement( 'general', 'baguette_settings' );
									if(this.getValue() == 'baguettebox') {
										element_id.getElement().show();
									}
									else {
										element_id.getElement().hide();
									}
								},
								commit : function( data ) {
									data.img_loader = this.getValue();
								}
							},
							{
								id:'img_margins',
								type:'text',
								label:'Margins (px)',
								validate: CKEDITOR.dialog.validate.integer(editor.lang.common.validateNumberFailed),
								'default':'',
								commit : function( data ) {
									data.img_margins = this.getValue();
								}
							},
					]},
					{
						type:'hbox',
						id:'baguette_settings',
						hidden : true,
						children:[
							{
								type: 'checkbox',
								id: 'baguette_first',
								label: 'Start a new gallery',
								title: 'Check if this image is the first in the gallery',
								'default': false,
								commit : function( data ) {
									data.baguette_first = this.getValue();
								}
							},
					]},
				]
			}
		],
		onOk : function() {
			var dialog = this, data = {}, reff = editor.document.createElement( 'a' ); 
			var styles = 'border: 0 none;';
			this.commitContent( data );
			if(data.img_margins) {
				styles = styles + ' margin: '+data.img_margins+'px;';
			}
			reff.setAttribute('href', data.img_url);
			if(data.img_loader == '_blank' || data.img_loader == '_self') {
				reff.setAttribute('target', data.img_loader);
			} else {
				reff.setAttribute('class', data.img_loader+'Box');
				if(data.img_loader != 'baguettebox') {
					reff.setAttribute('rel', data.img_loader+'[myGallery]');
				}
			}
			if(data.img_Align == 'left' || data.img_Align == 'right') {
				styles = styles + ' float: '+data.img_Align+';';
			}
			if(data.baguette_first) {
				divf = editor.document.createElement( 'div' );
				divf.setAttribute('class', 'baguettebox');
				divf.setHtml( '<a href="'+data.img_url+'"><img class="'+data.img_loader+'Img" alt="'+data.txtAlt+'" src="'+data.file_url+'" style="'+styles+'" /></a>' );
				editor.insertElement( divf );
			}
			else {
				reff.setHtml( '<img class="'+data.img_loader+'Img" alt="'+data.txtAlt+'" src="'+data.file_url+'" style="'+styles+'" />' );
			}
			editor.insertElement( reff );
		}
	};
});